import { IgCollection } from "igniteui-react-core/ES2015/IgCollection";
import { markType } from "igniteui-react-core/ES2015/type";
import { SyncableObservableCollection$2 } from "igniteui-react-core/ES2015/SyncableObservableCollection$2";
import { TimeAxisInterval as TimeAxisInterval_internal } from './TimeAxisInterval';
import { TimeAxisInterval as TimeAxisInterval } from './igr-time-axis-interval';
export class TimeAxisIntervalCollection extends IgCollection {
    constructor(list) {
        super();
        if (!TimeAxisInterval.$type) {
            TimeAxisInterval.$type = markType(TimeAxisInterval, "TimeAxisInterval");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!TimeAxisInterval.$type) {
            TimeAxisInterval.$type = markType(TimeAxisInterval, "TimeAxisInterval");
        }
        let coll = new SyncableObservableCollection$2(TimeAxisInterval.$type, TimeAxisInterval_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new TimeAxisInterval();
                ext._implementation = int;
            }
            return ext;
        };
        return coll;
    }
}
